<?php

namespace FiloBlu\DisableShop\Observer;

use Magento\Framework\Event\Observer as EventObserver;
use Magento\Framework\Event\ObserverInterface;

class ControllerActionPredispatch implements ObserverInterface {

    protected $_helper;
    protected $_storeManager;

    public function __construct(
    \FiloBlu\DisableShop\Helper\Data $helper, \Magento\Store\Model\StoreManagerInterface $storeManager
    ) {
        $this->_helper = $helper;
        $this->_storeManager = $storeManager;
    }

    /**
     * Apply is salable to product
     *
     * @param EventObserver $observer
     * @return $this
     */
    public function execute(EventObserver $observer) {
        
        if ($this->_helper->canDisableShop()) {
            $request = $observer->getRequest();
            $_fullActionName = $request->getFullActionName();
            $_notAllowedFullActionName = explode("\n", $this->_helper->getConfig("general/not_allowed_full_action_name"));
           
            if (in_array($_fullActionName, $_notAllowedFullActionName)) {
                $response = $observer->getControllerAction()->getResponse();
                $response->setRedirect($this->_storeManager->getStore()->getBaseUrl());
            }
        }

        return $this;
    }

}
